/* ccgo: sgf/prop.hh
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 *
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by thew Free Software Foundation.
 */

#ifndef SGF_PROP_HH
#define SGF_PROP_HH
#include "../go.hh"
#include "../proper.hh"
#include <string>
#include <vector>
#include <iostream>
namespace sgf
{
	class Prop
	{
		std::string id;
		std::vector<std::string> raw_values;
	public:
		bool load(std::istream &);
		void save(std::ostream &) const;
		const std::string & get_id() const;
		int as_int() const;
		double as_real() const;
		go::Loc as_loc(unsigned = 0) const;
		std::vector<go::Loc> ar_loc(unsigned = 0) const;
		char as_char() const;
		const std::string & as_string() const;
		go::Proper::Label as_label(unsigned = 0) const;
		std::vector<go::Proper::Label> ar_label(unsigned = 0) const;
	};
}

#endif // SGF_PROP_HH
